



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Part 4：表单和类视图--Django从入门到精通系列教程</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Part 4：表单和类视图--Django从入门到精通系列教程</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 12:17:35 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<hr>
<h3>该系列教程系个人原创，并完整发布在个人官网<a href="http://www.liujiangblog.com" rel="external nofollow noreferrer">刘江的博客和教程</a></h3>
<h3>所有转载本文者，需在顶部显著位置注明原作者及www.liujiangblog.com官网地址。</h3>
<hr>
<h2>一、表单form</h2>
<p>为了接收用户的投票选择，我们需要在前端页面显示一个投票界面。让我们重写先前的<code>polls/detail.html</code>文件，代码如下：</p>
<pre class="prettyprint linenums"><code>&lt;h1&gt;{{ question.question_text }}&lt;/h1&gt;

{% if error_message %}&lt;p&gt;&lt;strong&gt;{{ error_message }}&lt;/strong&gt;&lt;/p&gt;{% endif %}

&lt;form action=&quot;{% url 'polls:vote' question.id %}&quot; method=&quot;post&quot;&gt;<br />
{% csrf_token %}<br />
{% for choice in question.choice_set.all %}<br />
    &lt;input type=&quot;radio&quot; name=&quot;choice&quot; id=&quot;choice{{ forloop.counter }}&quot; value=&quot;{{ choice.id }}&quot; /&gt;<br />
    &lt;label for=&quot;choice{{ forloop.counter }}&quot;&gt;{{ choice.choice_text }}&lt;/label&gt;&lt;br /&gt;<br />
{% endfor %}<br />
&lt;input type=&quot;submit&quot; value=&quot;Vote&quot; /&gt;<br />
&lt;/form&gt;<br />
</code></pre>
<p>简要说明：</p>
<ul><li>上面的模板显示一系列单选按钮，按钮的值是选项的ID，按钮的名字是字符串&quot;choice&quot;。这意味着，当你选择了其中某个按钮，并提交表单，一个包含数据<code>choice=#</code>的POST请求将被发送到指定的url，<code>#</code>是被选择的选项的ID。这就是HTML表单的基本概念。</li>
<li>如果你有一定的前端开发基础，那么form标签的action属性和method属性你应该很清楚它们的含义，action表示你要发送的目的url，method表示提交数据的方式，一般分POST和GET。</li>
<li>forloop.counter是DJango模板系统专门提供的一个变量，用来表示你当前循环的次数，一般用来给循环项目添加有序数标。</li>
<li>由于我们发送了一个POST请求，就必须考虑一个跨站请求伪造的安全问题，简称CSRF（具体含义请百度）。Django为你提供了一个简单的方法来避免这个困扰，那就是在form表单内添加一条{% csrf_token %}标签，标签名不可更改，固定格式，位置任意，只要是在form表单内。这个方法对form表单的提交方式方便好使，但如果是用ajax的方式提交数据，那么就不能用这个方法了。</li></ul>
<p>现在，让我们创建一个处理提交过来的数据的视图。前面我们已经写了一个“占坑”的vote视图的url（polls/urls.py）：</p>
<pre class="prettyprint linenums"><code>url(r'^(?P&lt;question_id&gt;[0-9]+)/vote/$', views.vote, name='vote'),<br />
</code></pre>
<p>以及“占坑”的vote视图函数（polls/views.py），我们把坑填起来：</p>
<pre class="prettyprint linenums"><code>from django.shortcuts import get_object_or_404, render<br />
from django.http import HttpResponseRedirect, HttpResponse<br />
from django.urls import reverse<br />
from .models import Choice, Question<br />
# ...

def vote(request, question_id):<br />
    question = get_object_or_404(Question, pk=question_id)<br />
    try:<br />
        selected_choice = question.choice_set.get(pk=request.POST['choice'])<br />
    except (KeyError, Choice.DoesNotExist):<br />
        # 发生choice未找到异常时，重新返回表单页面，并给出提示信息<br />
        return render(request, 'polls/detail.html', {<br />
        'question': question,<br />
        'error_message': &quot;You didn't select a choice.&quot;,<br />
        })<br />
    else:<br />
        selected_choice.votes += 1<br />
        selected_choice.save()<br />
        # 成功处理数据后，自动跳转到结果页面，防止用户连续多次提交。<br />
        return HttpResponseRedirect(reverse('polls:results', args=(question.id,)))<br />
</code></pre>
<p>有些新的东西，我们要解释一下：</p>
<ul><li>request.POST是一个类似字典的对象，允许你通过键名访问提交的数据。本例中，<code>request.POST[’choice’]</code>返回被选择选项的ID，并且值的类型永远是string字符串，那怕它看起来像数字！同样的，你也可以用类似的手段获取GET请求发送过来的数据，一个道理。</li>
<li><code>request.POST[’choice’]</code>有可能触发一个KeyError异常，如果你的POST数据里没有提供choice键值，在这种情况下，上面的代码会返回表单页面并给出错误提示。PS：通常我们会给个默认值，防止这种异常的产生，例如<code>request.POST[’choice’,None]</code>，一个None解决所有问题。</li>
<li>在选择计数器加一后，返回的是一个<code>HttpResponseRedirect</code>而不是先前我们常用的<code>HttpResponse</code>。HttpResponseRedirect需要一个参数：重定向的URL。这里有一个建议，当你成功处理POST数据后，应当保持一个良好的习惯，始终返回一个HttpResponseRedirect。这不仅仅是对Django而言，它是一个良好的WEB开发习惯。</li>
<li>我们在上面HttpResponseRedirect的构造器中使用了一个<code>reverse()</code>函数。它能帮助我们避免在视图函数中硬编码URL。它首先需要一个我们在URLconf中指定的name，然后是传递的数据。例如<code>'/polls/3/results/'</code>，其中的3是某个<code>question.id</code>的值。重定向后将进入<code>polls:results</code>对应的视图，并将<code>question.id</code>传递给它。白话来讲，就是把活扔给另外一个路由对应的视图去干。</li></ul>
<p>当有人对某个问题投票后，vote()视图重定向到了问卷的结果显示页面。下面我们来写这个处理结果页面的视图(polls/views.py)：</p>
<pre class="prettyprint linenums"><code>from django.shortcuts import get_object_or_404, render

def results(request, question_id):<br />
    question = get_object_or_404(Question, pk=question_id)<br />
    return render(request, 'polls/results.html', {'question': question})<br />
</code></pre>
<p>同样，还需要写个模板<code>polls/templates/polls/results.html</code>。（路由、视图、模板、模型！都是这个套路....）</p>
<pre class="prettyprint linenums"><code>&lt;h1&gt;{{ question.question_text }}&lt;/h1&gt;<br />
&lt;ul&gt;<br />
{% for choice in question.choice_set.all %}<br />
    &lt;li&gt;{{ choice.choice_text }} -- {{ choice.votes }} vote{{ choice.votes|pluralize }}&lt;/li&gt;<br />
{% endfor %}<br />
&lt;/ul&gt;<br />
&lt;a href=&quot;{% url 'polls:detail' question.id %}&quot;&gt;Vote again?&lt;/a&gt;<br />
</code></pre>
<p>现在你可以到浏览器中访问<code>/polls/1/</code>了，投票吧。你会看到一个结果页面，每投一次，它的内容就更新一次。如果你提交的时候没有选择项目，则会得到一个错误提示。</p>
<p>如果你在前面漏掉了一部分操作没做，比如没有创建choice选项对象，那么可以按下面的操作，补充一下：</p>
<pre class="prettyprint linenums"><code>F:\Django_course\mysite&gt;python manage.py shell<br />
Python 3.6.1 (v3.6.1:69c0db5, Mar 21 2017, 18:41:36) [MSC v.1900 64 bit (AMD64)] on win32<br />
Type &quot;help&quot;, &quot;copyright&quot;, &quot;credits&quot; or &quot;license&quot; for more information.<br />
(InteractiveConsole)<br />
&gt;&gt;&gt; from polls.models import Question<br />
&gt;&gt;&gt; q = Question.objects.get(pk=1)<br />
&gt;&gt;&gt; q.choice_set.create(choice_text='Not much', votes=0)<br />
&lt;Choice: Choice object&gt;<br />
&gt;&gt;&gt; q.choice_set.create(choice_text='The sky', votes=0)<br />
&lt;Choice: Choice object&gt;<br />
&gt;&gt;&gt; q.choice_set.create(choice_text='Just hacking again', votes=0)<br />
&lt;Choice: Choice object&gt;<br />
</code></pre>
<p>为了方便大家，我将当前状态下的各主要文件内容一并贴出，供大家对照参考！</p>
<p>1--完整的<code>mysite/urls.py</code>文件如下：</p>
<pre class="prettyprint linenums"><code>from django.conf.urls import url,include<br />
from django.contrib import admin

urlpatterns = [<br />
    url(r'^admin/', admin.site.urls),<br />
    url(r'^polls/', include('polls.urls')),<br />
]<br />
</code></pre>
<p>2--完整的<code>mysite/settings.py</code>文件如下：</p>
<pre class="prettyprint linenums"><code>import os

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)<br />
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

# Quick-start development settings - unsuitable for production<br />
# See https://docs.djangoproject.com/en/1.11/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!<br />
SECRET_KEY = '85vvuta(p05ow!4pz2b0qbduu0%pq6x5q66-ei*pg+-lbdr#m^'

# SECURITY WARNING: don't run with debug turned on in production!<br />
DEBUG = True

ALLOWED_HOSTS = []

# Application definition

INSTALLED_APPS = [<br />
    'polls',<br />
    'django.contrib.admin',<br />
    'django.contrib.auth',<br />
    'django.contrib.contenttypes',<br />
    'django.contrib.sessions',<br />
    'django.contrib.messages',<br />
    'django.contrib.staticfiles',<br />
]

MIDDLEWARE = [<br />
    'django.middleware.security.SecurityMiddleware',<br />
    'django.contrib.sessions.middleware.SessionMiddleware',<br />
    'django.middleware.common.CommonMiddleware',<br />
    'django.middleware.csrf.CsrfViewMiddleware',<br />
    'django.contrib.auth.middleware.AuthenticationMiddleware',<br />
    'django.contrib.messages.middleware.MessageMiddleware',<br />
    'django.middleware.clickjacking.XFrameOptionsMiddleware',<br />
]

ROOT_URLCONF = 'mysite.urls'

TEMPLATES = [<br />
    {<br />
        'BACKEND': 'django.template.backends.django.DjangoTemplates',<br />
        'DIRS': [os.path.join(BASE_DIR, 'templates')]<br />
        ,<br />
        'APP_DIRS': True,<br />
        'OPTIONS': {<br />
            'context_processors': [<br />
                'django.template.context_processors.debug',<br />
                'django.template.context_processors.request',<br />
                'django.contrib.auth.context_processors.auth',<br />
                'django.contrib.messages.context_processors.messages',<br />
            ],<br />
        },<br />
    },<br />
]

WSGI_APPLICATION = 'mysite.wsgi.application'

# Database<br />
# https://docs.djangoproject.com/en/1.11/ref/settings/#databases

DATABASES = {<br />
    'default': {<br />
        'ENGINE': 'django.db.backends.sqlite3',<br />
        'NAME': os.path.join(BASE_DIR, 'db.sqlite3'),<br />
    }<br />
}

# Password validation<br />
# https://docs.djangoproject.com/en/1.11/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [<br />
    {<br />
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',<br />
    },<br />
    {<br />
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',<br />
    },<br />
    {<br />
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',<br />
    },<br />
    {<br />
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',<br />
    },<br />
]

# Internationalization<br />
# https://docs.djangoproject.com/en/1.11/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'Asia/Shanghai'

USE_I18N = True

USE_L10N = True

USE_TZ = True<br />
</code></pre>
<p>3--完整的<code>polls/views.py</code>应该如下所示：</p>
<pre class="prettyprint linenums"><code>from django.shortcuts import reverse<br />
from django.shortcuts import HttpResponseRedirect<br />
from django.shortcuts import get_object_or_404<br />
from django.shortcuts import HttpResponse<br />
from django.shortcuts import render<br />
from .models import Choice<br />
from .models import Question<br />
from django.template import loader<br />
# Create your views here.

def index(request):<br />
    latest_question_list = Question.objects.order_by('-pub_date')[:5]<br />
    template = loader.get_template('polls/index.html')<br />
    context = {<br />
        'latest_question_list': latest_question_list,<br />
    }<br />
    return HttpResponse(template.render(context, request))

def detail(request, question_id):<br />
    question = get_object_or_404(Question, pk=question_id)<br />
    return render(request, 'polls/detail.html', {'question': question})

def results(request, question_id):<br />
    question = get_object_or_404(Question, pk=question_id)<br />
    return render(request, 'polls/results.html', {'question': question})

def vote(request, question_id):<br />
    question = get_object_or_404(Question, pk=question_id)<br />
    try:<br />
        selected_choice = question.choice_set.get(pk=request.POST['choice'])<br />
    except (KeyError, Choice.DoesNotExist):<br />
        return render(request, 'polls/detail.html', {<br />
            'question': question,<br />
            'error_message': &quot;You didn't select a choice.&quot;,<br />
        })<br />
    else:<br />
        selected_choice.votes += 1<br />
        selected_choice.save()<br />
        return HttpResponseRedirect(reverse('polls:results', args=(question.id,)))<br />
</code></pre>
<p>4--完整的<code>polls/urls.py</code>应该如下所示：</p>
<pre class="prettyprint linenums"><code>from django.conf.urls import url<br />
from . import views

app_name = 'polls'

urlpatterns = [<br />
    # ex: /polls/<br />
    url(r'^$', views.index, name='index'),<br />
    # ex: /polls/5/<br />
    url(r'^(?P&lt;question_id&gt;[0-9]+)/$', views.detail, name='detail'),<br />
    # ex: /polls/5/results/<br />
    url(r'^(?P&lt;question_id&gt;[0-9]+)/results/$', views.results, name='results'),<br />
    # ex: /polls/5/vote/<br />
    url(r'^(?P&lt;question_id&gt;[0-9]+)/vote/$', views.vote, name='vote'),<br />
]<br />
</code></pre>
<p>5--完整的<code>polls/model.py</code>文件如下：</p>
<pre class="prettyprint linenums"><code>from django.db import models<br />
import datetime<br />
from django.utils import timezone<br />
# Create your models here.

class Question(models.Model):<br />
    question_text = models.CharField(max_length=200)<br />
    pub_date = models.DateTimeField('date published')

    def was_published_recently(self):<br />
        return self.pub_date &gt;= timezone.now() - datetime.timedelta(days=1)

    def __str__(self):<br />
        return self.question_text

class Choice(models.Model):<br />
    question = models.ForeignKey(Question, on_delete=models.CASCADE)<br />
    choice_text = models.CharField(max_length=200)<br />
    votes = models.IntegerField(default=0)

    def __str__(self):<br />
        return self.choice_text<br />
</code></pre>
<p>6--完整的<code>polls/admin.py</code>文件如下：</p>
<pre class="prettyprint linenums"><code>from django.contrib import admin

# Register your models here.

from .models import Question

admin.site.register(Question)<br />
</code></pre>
<p>7--完整的<code>templates/polls/index.html</code>文件如下：</p>
<pre class="prettyprint linenums"><code>{% if latest_question_list %}<br />
    &lt;ul&gt;<br />
    {% for question in latest_question_list %}<br />
        &lt;li&gt;&lt;a href=&quot;/polls/{{ question.id }}/&quot;&gt;{{ question.question_text }}&lt;/a&gt;&lt;/li&gt;<br />
    {% endfor %}<br />
    &lt;/ul&gt;<br />
{% else %}<br />
    &lt;p&gt;No polls are available.&lt;/p&gt;<br />
{% endif %}<br />
</code></pre>
<p>8--完整的<code>templates/polls/detail.html</code>文件如下：</p>
<pre class="prettyprint linenums"><code>&lt;h1&gt;{{ question.question_text }}&lt;/h1&gt;

{% if error_message %}&lt;p&gt;&lt;strong&gt;{{ error_message }}&lt;/strong&gt;&lt;/p&gt;{% endif %}

&lt;form action=&quot;{% url 'polls:vote' question.id %}&quot; method=&quot;post&quot;&gt;<br />
{% csrf_token %}<br />
{% for choice in question.choice_set.all %}<br />
    &lt;input type=&quot;radio&quot; name=&quot;choice&quot; id=&quot;choice{{ forloop.counter }}&quot; value=&quot;{{ choice.id }}&quot; /&gt;<br />
    &lt;label for=&quot;choice{{ forloop.counter }}&quot;&gt;{{ choice.choice_text }}&lt;/label&gt;&lt;br /&gt;<br />
{% endfor %}<br />
&lt;input type=&quot;submit&quot; value=&quot;Vote&quot; /&gt;<br />
&lt;/form&gt;<br />
</code></pre>
<p>9--完整的<code>templates/polls/results.html</code>文件如下：</p>
<pre class="prettyprint linenums"><code>&lt;h1&gt;{{ question.question_text }}&lt;/h1&gt;<br />
&lt;ul&gt;<br />
{% for choice in question.choice_set.all %}<br />
    &lt;li&gt;{{ choice.choice_text }} -- {{ choice.votes }} vote{{ choice.votes|pluralize }}&lt;/li&gt;<br />
{% endfor %}<br />
&lt;/ul&gt;<br />
&lt;a href=&quot;{% url 'polls:detail' question.id %}&quot;&gt;Vote again?&lt;/a&gt;<br />
</code></pre>
<p>vote()视图没有对应的html模板，它直接跳转到results视图去了。</p>
<p>运行服务器，测试各功能：</p>
<p>这是问卷列表页面：</p>
<p><img referrerpolicy="no-referrer"src="http://static.zybuluo.com/feixuelove1009/7pdy5vvn8to2ntg7w46ker09/image.png"></p>
<p>这是“what's up”问卷选项页面：</p>
<p><img referrerpolicy="no-referrer"src="http://static.zybuluo.com/feixuelove1009/ph5kz2fspfjpn287tci35dg8/image.png"></p>
<p>这是选择结果页面：</p>
<p><img referrerpolicy="no-referrer"src="http://static.zybuluo.com/feixuelove1009/y09ovdw2cibwair93z8hrwht/image.png"></p>
<p>这是没有选择选项时，提示错误信息的页面：</p>
<p><img referrerpolicy="no-referrer"src="http://static.zybuluo.com/feixuelove1009/4zdzz8lndebmgegi30fj9nf3/image.png"></p>
<p>请大家对比参考上面的内容，看看你自己的结果是否一样。</p>
<h2>二、 使用类视图：减少重复代码</h2>
<p>上面的detail、index和results视图的代码非常相似，有点冗余，这是一个程序猿不能忍受的。他们都具有类似的业务逻辑，实现类似的功能：通过从URL传递过来的参数去数据库查询数据，加载一个模板，利用刚才的数据渲染模板，返回这个模板。由于这个过程是如此的常见，Django很善解人意的帮你想办法偷懒，于是它提供了一种快捷方式，名为“类视图”。</p>
<p>现在，让我们来试试看将原来的代码改为使用类视图的方式，整个过程分三步走：</p>
<ul><li>修改URLconf设置</li>
<li>删除一些旧的无用的视图</li>
<li>采用基于类视图的新视图</li></ul>
<p><strong>PS：为什么本教程的代码来回改动这么频繁？</strong></p>
<p>答：通常在写一个Django的app时，我们一开始就要决定使用类视图还是不用，而不是等到代码写到一半了才重构你的代码成类视图。但是本教程为了让你清晰的理解视图的内涵，“故意”走了一条比较曲折的路，因为我们的哲学是<code>在你使用计算器之前你得先知道基本的数学公式</code>。</p>
<h3>1.<strong>改良URLconf</strong></h3>
<p>打开<code>polls/urls.py</code>文件，将其修改成下面的样子：</p>
<pre class="prettyprint linenums"><code>from django.conf.urls import url<br />
from . import views

app_name = 'polls'<br />
urlpatterns = [<br />
    url(r'^$', views.IndexView.as_view(), name='index'),<br />
    url(r'^(?P&lt;pk&gt;[0-9]+)/$', views.DetailView.as_view(), name='detail'),<br />
    url(r'^(?P&lt;pk&gt;[0-9]+)/results/$', views.ResultsView.as_view(), name='results'),<br />
    url(r'^(?P&lt;question_id&gt;[0-9]+)/vote/$', views.vote, name='vote'),<br />
]<br />
</code></pre>
<p>请注意：在上面的的第2,3条目中将原来的<code>&lt;question_id&gt;</code>修改成了<code>&lt;pk&gt;</code>.</p>
<h3>2.<strong>修改视图</strong></h3>
<p>接下来，打开<code>polls/views.py</code>文件，删掉index、detail和results视图，替换成Django的类视图，如下所示：</p>
<pre class="prettyprint linenums"><code>from django.shortcuts import get_object_or_404, render<br />
from django.http import HttpResponseRedirect<br />
from django.urls import reverse<br />
from django.views import generic<br />
from .models import Choice, Question

class IndexView(generic.ListView):<br />
    template_name = 'polls/index.html'<br />
    context_object_name = 'latest_question_list'<br />
    def get_queryset(self):<br />
    &quot;&quot;&quot;返回最近发布的5个问卷.&quot;&quot;&quot;<br />
        return Question.objects.order_by('-pub_date')[:5]

class DetailView(generic.DetailView):<br />
    model = Question<br />
    template_name = 'polls/detail.html'

class ResultsView(generic.DetailView):<br />
    model = Question<br />
    template_name ='polls/results.html'

def vote(request, question_id):<br />
... # 这个视图未改变！！！<br />
</code></pre>
<p>在这里，我们使用了两种类视图<code>ListView</code>和<code>DetailView</code>（它们是作为父类被继承的）。这两者分别代表“显示一个对象的列表”和“显示特定类型对象的详细页面”的抽象概念。</p>
<ul><li><p>每一种类视图都需要知道它要作用在哪个模型上，这通过model属性提供。</p></li>
<li><p><code>DetailView</code>类视图需要从url捕获到的称为&quot;pk&quot;的主键值，因此我们在url文件中将2和3条目的<code>&lt;question_id&gt;</code>修改成了<code>&lt;pk&gt;</code>。</p></li></ul>
<p>默认情况下，<code>DetailView</code>类视图使用一个称作<code>&lt;app name&gt;/&lt;model name&gt;_detail.html</code>的模板。在本例中，实际使用的是<code>polls/detail.html</code>。<code>template_name</code>属性就是用来指定这个模板名的，用于代替自动生成的默认模板名。（一定要仔细观察上面的代码，对号入座，注意细节。）同样的，在resutls列表视图中，指定<code>template_name</code>为<code>'polls/results.html'</code>，这样就确保了虽然resulst视图和detail视图同样继承了DetailView类，使用了同样的model：Qeustion，但它们依然会显示不同的页面。（模板不同嘛！so easy！）</p>
<p>类似的，ListView类视图使用一个默认模板称为<code>&lt;app name&gt;/&lt;model name&gt;_list.html</code>。我们也使用<code>template_name</code>这个变量来告诉ListView使用我们已经存在的<br /><br />
<code>&quot;polls/index.html&quot;</code>模板，而不是使用它自己默认的那个。</p>
<p>在教程的前面部分，我们给模板提供了一个包含<code>question</code>和<code>latest_question_list</code>的上下文变量。而对于DetailView，question变量会被自动提供，因为我们使用了Django的模型（Question），Django会智能的选择合适的上下文变量。然而，对于ListView，自动生成的上下文变量是<code>question_list</code>。为了覆盖它，我们提供了<code>context_object_name</code>属性，指定说我们希望使用<code>latest_question_list</code>而不是<code>question_list</code>。</p>
<p>现在可以运行开发服务器，然后试试基于类视图的应用程序了。类视图是Django比较高级的一种用法，初学可能不太好理解，没关系，我们先有个印象。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zn2538.html">网络编程-socket</a>
		</li>
						<li><a href="https://www.batexi.com/a/390xz139.html">2016中国VR开发者论坛第一期</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j5eeg8.html">IIS配置ASP&period;NET和服务器错误页</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jwn408.html">php基础28：文件读取</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4e0zj9.html">linux 文件目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xdy6z9.html">hadoop&mdash;&mdash;在命令行下编译并运行map-reduce程序  2</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vy74m8.html">为 PHP 开发者准备的 12 个调试工具&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmoe549.html">ipython with ubuntu</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge1rze8.html">layout&lowbar;weight属性详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1v0xoq.html">PowerDesigner反projectM连接ySql没有mySql odbc驱动器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdm4jd9.html">转：用&ZeroWidthSpace;C&ZeroWidthSpace;语&ZeroWidthSpace;言&ZeroWidthSpace;的&ZeroWidthSpace;r&ZeroWidthSpace;a&ZeroWidthSpace;n&ZeroWidthSpace;d&ZeroWidthSpace;&lpar;&ZeroWidthSpace;&rpar;&ZeroWidthSpace;和&ZeroWidthSpace;s&ZeroWidthSpace;r&ZeroWidthSpace;a&ZeroWidthSpace;n&ZeroWidthSpace;d&ZeroWidthSpace;&lpar;&ZeroWidthSpace;&rpar;&ZeroWidthSpace;产&ZeroWidthSpace;生&ZeroWidthSpace;伪&ZeroWidthSpace;随&ZeroWidthSpace;机&ZeroWidthSpace;数&ZeroWidthSpace;的&ZeroWidthSpace;方&ZeroWidthSpace;法&ZeroWidthSpace;总&ZeroWidthSpace;结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j1zmw8.html">【IOS 开发】基本 UI 控件详解 &lpar;UISegmentedControl &vert; UIImageView &vert; UIProgressView &vert; UISlider &vert; UIAlertView &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgrxg78.html">5月第2周业务风控关注 &vert; 央行：严禁未经授权认可的APP接入征信系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy17rdxq.html">TensorFlow之CNN：运用Batch Norm、Dropout和早停优化卷积神经网络</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rr7w48.html">&lbrack;PKUWC2018&rsqb; Minimax</a>
		</li>
						<li><a href="https://www.batexi.com/a/960mwyy9.html">【XSY2668】排列统计 DP</a>
		</li>
						<li><a href="https://www.batexi.com/a/960lvjj9.html">mysql优化-数据库优化、SQL优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gv5yvq.html">hdu 1025 上面n个点与下面n个点对应连线 求最多能连有多少条不相交的线  （LIS）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o62dx8.html">linux中awk命令学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zymrp39.html">MyBatis中实现多表查询</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv1n1w1q.html">Java DB访问之 JDBC</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzg1j08.html">html笔记2</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj7lz19.html">【转载】Java 内存分配全面浅析</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojodjeq.html">hdu&lowbar;1370Biorhythms&lpar;互素的中国剩余定理&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k2p629.html">在tomcat中布置项目的介绍（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/950ym4v8.html">MFC中菜单的命令响应顺序</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mezpxpq.html">【深度学习系列】CNN模型的可视化</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yknl08.html">属性getter和setter</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj05r38.html">关于jquery ajax跨域请求获取response headers问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jvy6v8.html">Java数据持久层框架 MyBatis之API学习四（xml配置文件详解）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
